unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, System.IniFiles,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Menus,
  FMX.Layouts, FMX.Memo;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
  private
    { private 錾 }
    FName : string;
    procedure OpenIniFile;
    procedure SaveIniFile;
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.OpenIniFile;
var
    IniFile : TIniFile;
begin
   IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
   try
      Form1.Left  := IniFile.ReadInteger('Form','X',0);
      Form1.Top   := IniFile.ReadInteger('Form','Y',0);
      Form1.Width := IniFile.ReadInteger('Form','W',320);
      Form1.Height:= IniFile.ReadInteger('Form','H',240);
      FName := IniFile.ReadString('FILE','Name','');
   except
      ;
   end;
   IniFile.Free;
end;

procedure TForm1.SaveIniFile;
var
    IniFile : TIniFile;
begin
   IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
   try
      IniFile.WriteInteger('Form','X', Form1.Left);
      IniFile.WriteInteger('Form','Y', Form1.Top);
      IniFile.WriteInteger('Form','W', Form1.Width);
      IniFile.WriteInteger('Form','H', Form1.Height);
      IniFile.WriteString('File','Name', FName);
   except
      ;
   end;
   IniFile.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   FName := '';

   OpenIniFile;

   Memo1.SetFocus;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   if (MessageDlg('I܂B낵łH',
          TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrNo) then begin
      CanClose := False;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveIniFile;
end;

// [t@C] - [VK쐬]
procedure TForm1.MenuItem2Click(Sender: TObject);
begin
   if (MessageDlg('VK쐬s܂B݂͔͂̕j܂B낵łH',
          TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes) then begin
      Memo1.SelLength:= 0;
      Memo1.SelStart := 0;
      Memo1.Lines.Clear;
   end;
end;

// [t@C] - [J]
procedure TForm1.MenuItem3Click(Sender: TObject);
var
   f : string;
begin
   OpenDialog1.InitialDir := ExtractFilePath(FName);
   OpenDialog1.FileName   := ExtractFileName(FName);
   if (OpenDialog1.Execute) then begin
      f := OpenDialog1.FileName;
      if (FileExists(f)) then begin
         Memo1.SelLength:= 0;
         Memo1.SelStart := 0;
         Memo1.Lines.Clear;
         try
            Memo1.Lines.LoadFromFile(f);
            FName := f;
         finally
            ;
         end;
      end;
   end;
end;

// [t@C] - [Oĕۑ]
procedure TForm1.MenuItem4Click(Sender: TObject);
var
   f : string;
begin
   SaveDialog1.InitialDir := ExtractFilePath(FName);
   SaveDialog1.FileName   := ExtractFileName(FName);
   if (SaveDialog1.Execute) then begin
      f := SaveDialog1.FileName;
      try
         Memo1.Lines.SaveToFile(f,TEncoding.UTF8);
         FName := f;
      finally
         ;
      end;
   end;
end;

// [t@C] - [I]
procedure TForm1.MenuItem5Click(Sender: TObject);
begin
   close;
end;

// [ҏW] - [ɖ߂]
procedure TForm1.MenuItem7Click(Sender: TObject);
begin
   try
      Memo1.UnDo;
   except
      ;
   end;
   // AhDƁAMemoR|[lg
   // ُ퓮܂
end;

// [ҏW] - [؂iJbgj]
procedure TForm1.MenuItem9Click(Sender: TObject);
begin
   try
      Memo1.CutToClipboard;
   except
      ;
   end;
end;

// [ҏW] - [Rs[]
procedure TForm1.MenuItem10Click(Sender: TObject);
begin
   try
      Memo1.CopyToClipboard;
   except
      ;
   end;
end;

// [ҏW] - [\tiy[Xgj]
procedure TForm1.MenuItem11Click(Sender: TObject);
var
   i,j : integer;
begin
   i := Memo1.SelStart;
   j := Length(Memo1.Text);
   try
      Memo1.PasteFromClipboard;
      j := Length(Memo1.Text) - j;
      Memo1.SelStart := i + j;
   except
      ;
   end;
end;

// [ҏW] - [폜]
procedure TForm1.MenuItem12Click(Sender: TObject);
begin
   try
      Memo1.DeleteSelection;
   except
      ;
   end;
end;

end.
